/*
 * ================================================================================
 * VoiceTest
 * Copyright (C) 2011 Asher "asherkin" Baker.  All rights reserved.
 * ================================================================================
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3.0, as published by the
 * Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "extension.h"

VoiceTest g_VoiceTest;

SMEXT_LINK(&g_VoiceTest);

IVoice *g_pVoice = NULL;
IForward *g_pForwardOnVoiceBroadcast = NULL;

void VoiceTest::OnVoiceBroadcast(int client, char *pVoiceData, int *nSamples)
{
	//g_SMAPI->ConPrintf("Recording %d samples of voice data for client %d.\n", *nSamples, client);
	g_pForwardOnVoiceBroadcast->PushCell(client);
	g_pForwardOnVoiceBroadcast->Execute(NULL);
}

bool VoiceTest::SDK_OnLoad(char *error, size_t maxlen, bool late)
{
	g_pForwardOnVoiceBroadcast = g_pForwards->CreateForward("OnClientSpeaking", ET_Ignore, 1, NULL, Param_Cell);
	return true;
}

void VoiceTest::SDK_OnUnload()
{
	g_pForwards->ReleaseForward(g_pForwardOnVoiceBroadcast);
}

bool VoiceTest::SDK_OnMetamodLoad(ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	int ifaceerror;
	g_pVoice = (IVoice *)g_SMAPI->MetaFactory(VOICE_INTERFACE, &ifaceerror, NULL);
	if (!g_pVoice)
	{
		snprintf(error, maxlen, "Could not find interface %s (error %d)", VOICE_INTERFACE, ifaceerror);
		return false;
	}

	g_pVoice->AddRawVoiceListener(this);

	return true;
}

bool VoiceTest::SDK_OnMetamodUnload(char *error, size_t maxlen)
{
	g_pVoice->RemoveRawVoiceListener(this);

	return true;
}
